import { AbstractControl } from '@angular/forms';
import { Pointer } from './jsonpointer.functions';
/**
 * FormGroup function library:
 *
 * buildFormGroupTemplate:  Builds a FormGroupTemplate from schema
 *
 * buildFormGroup:          Builds an Angular FormGroup from a FormGroupTemplate
 *
 * mergeValues:
 *
 * setRequiredFields:
 *
 * formatFormData:
 *
 * getControl:
 *
 * ---- TODO: ----
 * TODO: add buildFormGroupTemplateFromLayout function
 * buildFormGroupTemplateFromLayout: Builds a FormGroupTemplate from a form layout
 */
/**
 * 'buildFormGroupTemplate' function
 *
 * Builds a template for an Angular FormGroup from a JSON Schema.
 *
 * TODO: add support for pattern properties
 * https://spacetelescope.github.io/understanding-json-schema/reference/object.html
 */
export declare function buildFormGroupTemplate(jsf: any, nodeValue?: any, setValues?: boolean, schemaPointer?: string, dataPointer?: string, templatePointer?: string): {
    controlType: "FormGroup";
    controls: any;
    validators: any;
    value?: undefined;
} | {
    controlType: "FormArray";
    controls: any;
    validators: any;
    value?: undefined;
} | {
    controlType: "FormControl";
    value: {
        value: any;
        disabled: any;
    };
    validators: any;
    controls?: undefined;
};
/**
 * 'buildFormGroup' function
*/
export declare function buildFormGroup(template: any): AbstractControl;
/**
 * 'mergeValues' function
 */
export declare function mergeValues(...valuesToMerge: any[]): any;
/**
 * 'setRequiredFields' function
 */
export declare function setRequiredFields(schema: any, formControlTemplate: any): boolean;
/**
 * 'formatFormData' function
 */
export declare function formatFormData(formData: any, dataMap: Map<string, any>, recursiveRefMap: Map<string, string>, arrayMap: Map<string, number>, returnEmptyFields?: boolean, fixErrors?: boolean): any;
/**
 * 'getControl' function
 *
 * Uses a JSON Pointer for a data object to retrieve a control from
 * an Angular formGroup or formGroup template. (Note: though a formGroup
 * template is much simpler, its basic structure is idential to a formGroup).
 *
 * If the optional third parameter 'returnGroup' is set to TRUE, the group
 * containing the control is returned, rather than the control itself.
 */
export declare function getControl(formGroup: any, dataPointer: Pointer, returnGroup?: boolean): any;
